data = {'news20.binary';'rcv1_test.binary';'epsilon_normalized';'webspam_wc_normalized_trigram.svm';'url_combined';'kddb';'criteo';'kdd2012'};
C = {'0.001','1','1000.0'};
instances = [19996, 677399, 400000, 350000, 2396130, 19264097,45840617,14664569];
features = [1355191, 47236, 2000, 16609143, 3231961, 29890095,999999,19144857];
dname = {'news20';'rcv1t';'epsilon';'webspam';'url';'KDD2010-b';'criteo';'kdd2012'};

load const

for i =1:length(ds)
	if (ds(i) == 0)
		continue;
	end
	for l=1:length(C)
		if (Cs(l) == 0)
			continue;
		end
		for j=1:length(solvers)
			file_name = ['log/' data{i} '.C' C{l} '.' solvers{j}  '.log'];
			fid = fopen(file_name,'r');
			counter(j) = 0;
			while ~feof(fid)
				line = fgetl(fid);
				if line == -1
					break;
				end
				t = strread(line,'%s','delimiter',' \t');
				if length(t) < 1 || ~strcmp(t{1},'iter')
					continue;
				end
				counter(j) = counter(j) + 1;
				for k=1:length(t)-1
					if strcmp(t{k}, 'f')
						fun(j,counter(j)) = str2double(t{k+1});
					elseif strcmp(t{k}, 'time')
						timer(j,counter(j)) = str2double(t{k+1});
						break;
					end
				end
			end
		end
		maxer = max(fun(:,1)) / opt{l}(i);

		fun = fun/ opt{l}(i) - 1;
		h = figure;
		for s=1:length(solvers)
			if s ==1
				semilogy(timer(s,1:counter(s)),fun(s,1:counter(s)));
				hold on;
			else
				semilogy(timer(s,1:counter(s)),fun(s,1:counter(s)));
			end
		end
		set(gca,'fontsize',24);
		title1 = sprintf('%s: l = %d, n = %d',dname{i},instances(i),features(i));
		title(title1);
		xlabel('Training Time (Seconds)','FontSize',30);
		ylabel('Difference to Opt. Fun. Value','FontSize',30);
		le=legend(solvers);
		if (stops(i,l,1) > 0)
			semilogy(get(gca,'xlim'),[stops(i,l,1), stops(i,l,1)],'Linewidth',4);
		end
		if (stops(i,l,2) > 0)
			semilogy(get(gca,'xlim'),[stops(i,l,2), stops(i,l,2)],'Linewidth',4);
		end
		if (stops(i,l,3) > 0)
			semilogy(get(gca,'xlim'),[stops(i,l,3), stops(i,l,3)],'Linewidth',4);
		end
		set (le,'FontSize',24);
		ylim([opt2{l}(i) maxer]);
		print(h,'-dpng',['figures/' data{i} '.C' C{l} '.time.png']);
		clear h;
		close all;
		clear fun;
		clear timer;
		clear counter;
	end
end
